(ns dmr.db
  (:require [shadow.resource :as rc]))

; TODO remove this duplication
; TODO find a way to load this data at runtime

(def open-game-license
  (-> "5e-database/5e-SRD-License.json"
      rc/inline
      (#(.parse js/JSON %))
      (js->clj :keywordize-keys true)))

(def ogl-notice
    {:content-kind "Open Game Content"
     :license-name "Open Game License"})

(defn- add-ogl-notice
    [x]
    (assoc x :license-notice ogl-notice))

(def srd-data {:spells (rc/inline "5e-database/5e-SRD-Spells.json")
               :equipment (rc/inline "5e-database/5e-SRD-Equipment.json")})

(defn- parse-srd-data [raw-data]
  (as-> raw-data x
      (.parse js/JSON x)
      (js->clj x :keywordize-keys true)
      (map add-ogl-notice x)))

(defn- fmap [f m] (zipmap (keys m) (map f (vals m))))

(def default-db
  {:name "DMR"
   :cmdline {:current ""
             :suggestions {:options nil :selected nil}
             :selected-history nil
             :history []}
   :entities (fmap parse-srd-data srd-data)
   :license open-game-license})
